
EnableExplicit

;SYNTHETIC DREAMS
;Author Mijikai

XIncludeFile "nautilus.pbi"

Structure VECTOR_STRUCT
  x.f
  y.f
EndStructure

Structure FX
  a.f
  b.VECTOR_STRUCT
  c.i
EndStructure

#TITLE = "SYNTHETIC DREAMS"

Procedure.i Main()
  Protected *engine.NE_ENGINE
  Protected engine_delta.f
  Protected engine_fps.i
  Protected engine_error.i
  Protected screen_center.VECTOR_STRUCT
  Protected index.f
  Protected flip.i
  Protected anc.f
  Protected rot.f
  Protected w.f
  Protected h.f
  Protected draw.i
  Protected NewList npos.FX()
  Protected rest.f
  Protected aa.f
  Protected bb.f
  Protected af.f
  Protected bf.f
  *engine = nautilusWindow(#TITLE + " by Mijikai",1080,720,#NE_WINDOW_SIZEABLE,900,300,60)
  If *engine
    *engine\RenderAspect()  
    *engine\RenderColor($2E0000)
    *engine\ScreenCenter(@screen_center)
    aa = 20
    bb = 20
    af = 70
    bf = 40
    Repeat
      If *engine\RenderBegin(@engine_delta,@engine_fps)
        draw = 0  
        If index > 6
          If flip
            anc - 4
            flip = Bool(anc > -af)
          Else
            anc + 1
            flip = Bool(anc > bf)
          EndIf
          index = engine_delta
        Else
          index + 1 * engine_delta
          rot + 1 * engine_delta
          If rot > 359
            rot = 0
          EndIf
        EndIf
        w = aa - anc
        h = bb + anc
        ForEach npos()
          *engine\DrawTextModEx(screen_center\x,screen_center\y,#TITLE,npos()\b\x,npos()\b\y,#True,#True,60,npos()\a,npos()\c)
          *engine\DrawTextModEx(screen_center\x,screen_center\y,#TITLE,npos()\b\x,npos()\b\y,#True,#True,60,-npos()\a,npos()\c)
          draw + 32
        Next
        If ListSize(npos()) < 168
          If AddElement(npos())
            npos()\a = anc
            npos()\b\x = -200 + Abs(w) + rot
            npos()\b\y = 800 + Abs(h) - rot
            npos()\c = RGB(rot,0,255 - rot)
          EndIf 
        EndIf
        *engine\DrawTextLightModEx(screen_center\x,screen_center\y,#TITLE,w,h,#True,#True,anc,$FFFFFFFF)
        *engine\DrawTextLightModEx(screen_center\x + 3,screen_center\y + 1,#TITLE,w,h,#True,#True,anc,$FF4060FF)
        draw + 32 
        ;*engine\DrawText(10,10,Str(draw))
        ;*engine\DrawText(10,20,Str(engine_fps))
        If rest > 100
          ClearList(npos())
          rest = engine_delta
          aa = 20 + Random(100)
          bb = 20 + Random(200)
          af = 40 + Random(300)
          bf = 40 + Random(300)
        Else
          rest + engine_delta
        EndIf
        *engine\RenderEnd()
      EndIf 
    Until nautilusWindowExit()
    nautilusWindowClose(*engine)
  EndIf 
EndProcedure

Main()

End
; IDE Options = PureBasic 5.62 (Windows - x64)
; CursorPosition = 6
; Folding = -
; EnableXP
; DisableDebugger